<template>
  <div class="goodsRepertory pagePadding">
    <ex-table
      v-loading="loading"
      v-if=" powers.some((i) => i == '001')"
      :table="table"
      :data="tableData"
      :columns="columns"
      :page="pageInfo"
      :size="size"
      @page-curr-change="handlePageChange"
      @page-size-change="handleSizeChange"
      @screen-reset="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @screen-submit="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
    >
      <template #table-header="{}">
        <div style="width: 100%">
          <el-row style="padding: 0 0 10px 80px">
            <el-col :span="4" style="width: 110px">
              <el-select
                v-model="parmValue.good_type"
                filterable
                clearable
                :size="searchSize"
                placeholder="定制类型"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in options1"
                  :key="'good_type' + item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-col>
            <!-- <el-col :span="6" style="width: 290px; padding: 0 0 0 10px">
              <period-date-picker
                :type="1"
                :width="'129px'"
                :size="searchSize"
                :start="parmValue.start"
                :end="parmValue.end"
                @timeReturned="handleTime"
              />
            </el-col> -->
            <el-col style="width: 120px; padding: 0 0 0 10px">
              <el-input
                v-model="parmValue.moq"
                placeholder="最低起订量"
                @blur="moq_change"
                type="number"
              ></el-input>
            </el-col>
            <el-col style="width: 120px; padding: 0 0 0 10px">
              <el-select
                v-model="parmValue.is_stock"
                filterable
                clearable
                :size="searchSize"
                placeholder="库存类型"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in options4"
                  :key="'good_type' + item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-col>
            <el-col :span="6" style="width: 310px; padding: 0 0 0 10px">
              <good-class
                :value="parmValue.cat_id"
                @handleChange="goods_class_change"
                :disabled="false"
                :size="searchSize"
                :isDetail="false"
                :placeholder="'分类'"
              />
            </el-col>

            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button type="warning" :size="searchSize" @click="restSearch">
                重置
              </el-button>
            </el-col>
          </el-row>

          <el-row>
            <!-- <el-col :span="4" style="width: 200px">
              <el-select
                v-model="parmValue.exam_status"
                filterable
                clearable
                :size="searchSize"
                placeholder="状态"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in options8"
                  :key="'status' + item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-col> -->

            <el-col :span="4" style="width: 190px">
              <search-brand
                :value="brandid"
                :disabled="type === 'view' || type === 'editCoin'"
                :size="'mini'"
                :isDetail="type !== 'add'"
                :names="brand_name"
                :placeholder="'商品品牌'"
                @searchChange="brandidsearchChange"
              />
            </el-col>
            <el-col :span="6" style="width: 290px; padding: 0 0 0 10px">
              <number-range
                :lower="parmValue.min_price"
                :online="parmValue.max_price"
                :title="'售价'"
                :width="'129px'"
                :size="searchSize"
                @numReturned="numReturned"
              />
            </el-col>

            <el-col :span="4" style="width: 310px; padding: 0 0 0 10px">
              <el-input
                :size="searchSize"
                v-model="sinput"
                :maxlength="40"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="关键字"
                ><el-select
                  v-model="select"
                  slot="prepend"
                  :size="searchSize"
                  style="width: 120px"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                  placeholder="关键字类型"
                >
                  <el-option label="商品名称" value="1" />
                  <el-option label="商品上线编号" value="2" />
                  <el-option label="商品成本编号" value="9" />
                  <!-- <el-option label="平台编号" value="3" /> -->
                  <!-- <el-option label="供应商编号" value="4" /> -->
                  <el-option label="业务企业编号" value="5" />
                  <el-option label="平台商品编号" value="6" />
                  <el-option label="创建人" value="7" />
                  <el-option label="创建人部门" value="8" /> </el-select
              ></el-input>
            </el-col>
            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button type="primary" :size="searchSize" @click="searchList">
                刷新
              </el-button>
            </el-col>
          </el-row>
        </div></template
      >
      <template #good_thumb_img="{ scope }">
        <div
          v-if="scope.row.good_thumb_img"
          style="width: 20px; height: 20px"
          class="hover"
          v-viewer
        >
          <img
            :src="scope.row.good_thumb_img"
            style="display: inline-block; width: 100%; height: 100%"
            alt=""
          />
        </div>
      </template>
      <template #status="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="
            scope.row.status == '6' ? '' : scope.row.status == '7' ? 'danger' : 'warning'
          "
          v-text="
            (options8.find((item) => item.id == scope.row.status) || {}).name || '--'
          "
        ></el-tag>
      </template>
      <template #good_type="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="scope.row.good_type == '0' ? 'warning' : ''"
          v-text="
            (options1.find((item) => item.id == scope.row.good_type) || {}).name || '--'
          "
        ></el-tag>
      </template>
      <template #is_stock="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="scope.row.is_stock == '0' ? 'warning' : ''"
          v-text="
            (options9.find((item) => item.id == scope.row.is_stock) || {}).name || '--'
          "
        ></el-tag>
      </template>

      <template #operation="{ scope }">
        <!-- v-if="powers.some((i) => i == '007')" -->
        <el-tooltip effect="dark" content="详情" placement="top">
          <i class="el-icon-view tb-icon" @click="openDilog(scope.row)"></i>
        </el-tooltip>
      </template>
    </ex-table>
    <no-auth v-else></no-auth>

    <show-goods-data-table-modal
      @cancel="visible = false"
      :showModel="visible"
      :type="'1'"
      :title="'线上商品详情'"
      :skuCode="row.skuCode"
      :spuCode="row.spuCode"
      :iscgd="false"
    />
  </div>
</template>
<script>
import asyncRequest from "@/apis/service/stock/goodsRepertory";
import mixinPage from "@/mixins/elPaginationHandle";
import { mapGetters } from "vuex";
import resToken from "@/mixins/resToken";
import { listCol, options1, options4, options8, options9 } from "./columns";
import showGoodsDataTableModal from "@/components/show-goods-data-table-modal";
export default {
  name: "goodsRepertory",
  mixins: [mixinPage, resToken],
  components: {
    showGoodsDataTableModal,
  },
  computed: {
    //组件SIZE设置
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find((i) => i.menu_route == "goodsRepertory") ||
        {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      row: {},
      visible: false,
      options1: options1,
      options4: options4,
      options8: options8,
      options9: options9,
      loading: false,
      parmValue: {
        good_name: "", //商品名称
        skucode: "",
        spucode: "", //商品编号
        cat_id: "", //商品分类
        start: "", //开始日期
        end: "", //结束日期
        platform_code: "", //平台编码
        is_stock: "", //是否库存品
        min_price: "", //价格区间最小值
        max_price: "", //价格区间最大值
        moq: "", //最小起订量
        page: 1, // 页码
        size: 15, // 每页显示条数
        supplierNo: "", //供应商编号
        good_type: "", //是否定制
        brand_id: "", //品牌
        companyNo: "", //业务企业编号
        // exam_status: "6", //审核状态
        plat_code: "", //平台商品编号
        company_name: "", //创建人部门
        creater: "", //
      },

      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: listCol,
      cat_id: [],
      brandid: [],
      select: "1",
      sinput: "",
    };
  },
  mounted() {
    this.cat_id = [];
    this.brandid = [];
    this.searchList();
  },
  methods: {
    //打开弹窗
    openDilog(row) {
      this.row = row;
      this.visible = true;
      console.log(this.row);
      console.log(this.visible);
    },

    restSearch() {
      this.cat_id = [];
      this.brandid = [];
      (this.select = "1"),
        (this.sinput = ""),
        // 表格 - 分页
        (this.pageInfo = {
          size: 15,
          curr: 1,
          total: 0,
        });
      this.parmValue = {
        good_name: "", //商品名称
        skucode: "",
        spucode: "", //商品编号
        cat_id: "", //商品分类
        start: "", //开始日期
        end: "", //结束日期
        platform_code: "", //平台编码
        is_stock: "", //是否库存品
        min_price: "", //价格区间最小值
        max_price: "", //价格区间最大值
        moq: "", //库存数量
        page: 1, // 页码
        size: 15, // 每页显示条数
        supplierNo: "", //供应商编号
        good_type: "", //是否定制
        brand_id: "", //品牌
        companyNo: "", //业务企业编号
        // exam_status: "6", //审核状态
        plat_code: "", //平台商品编号
        company_name: "", //创建人部门
        creater: "", //
      };
      this.searchList();
    },
    async moq_change() {
      const { moq } = this.parmValue;
      let moq_num = parseInt(moq * 1);
      if (moq_num == NaN) {
        this.parmValue.moq = "";
      } else {
        this.parmValue.moq = moq_num;
      }
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
    //商品品牌选择
    async brandidsearchChange(e) {
      const { id, code, label } = e;
      if (id) {
        this.brandid = [id];
      } else {
        this.brandid = [];
      }
      this.parmValue.brand_id = this.brandid.toString();
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
    // 时间
    async handleTime(e) {
      this.parmValue.start = e.startTime || "";
      this.parmValue.end = e.endTime || "";
      if (
        (this.parmValue.start !== "" && this.parmValue.end !== "") ||
        (this.parmValue.start === "" && this.parmValue.end === "")
      ) {
        this.pageInfo.curr = 1;
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    /**
     * 商品重新上线
     * @param {String} id id
     * @param {String} status 0-禁用 1-启用
     */
    async get_againonline(skuCode) {
      await this.$confirm(`确定要重新发起上线流程？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            skuCode: skuCode,
          };
          const res = await asyncRequest.againonline(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "重新发起上线流程成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.loading = false;
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    /**
     * 商品下线
     * @param {String} id id
     * @param {String} status 0-禁用 1-启用
     */
    async get_donline(skuCode) {
      await this.$confirm(`确定要下线商品？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            skuCode: skuCode,
            exam_status: "8",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "下线商品成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.loading = false;
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    /**
     * 启用/禁用
     * @param {String} id id
     * @param {String} status 0-禁用 1-启用
     */
    async changeStatus(id, status) {
      await this.$confirm(`确定要改为${status === "1" ? "禁用" : "启用"}？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.loading = false;
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async deleteItem(code) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            codes: [code],
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 刷新表格
    async searchList() {
      if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start === "" && this.parmValue.end !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }
      this.loading = true;
      let model = JSON.parse(JSON.stringify(this.parmValue));
      model.good_name = this.select === "1" ? this.sinput : ""; //商品名称
      model.skucode = this.select === "2" ? this.sinput : ""; //商品编号
      model.spucode = this.select === "9" ? this.sinput : ""; //商品编号
      // model.platform_code = this.select === "1" ? this.sinput : ""; //平台编码
      // model.supplierNo = this.select === "1" ? this.sinput : ""; //供应商编号
      model.companyNo = this.select === "5" ? this.sinput : ""; //业务企业编号
      // model.exam_status = this.select === "1" ? this.sinput : ""; //审核状态
      model.plat_code = this.select === "6" ? this.sinput : ""; //平台商品编号
      model.creater = this.select === "7" ? this.sinput : ""; //
      model.company_name = this.select === "8" ? this.sinput : ""; //
      const res = await asyncRequest.list(model);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.tableData.forEach((a) => {
          a.cat_name = "";
          let list = a.cat_info || [];
          list.forEach((b, i) => {
            a.cat_name += i == 0 ? b.name : "/" + b.name;
          });
        });
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },
    //商品分类选择
    async goods_class_change(e) {
      this.cat_id = e;
      this.parmValue.cat_id =
        this.cat_id.length === 0 ? "" : this.cat_id[this.cat_id.length - 1];
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },

    //价格区间变动触发请求
    async numReturned(msg) {
      this.parmValue.min_price = msg.lower;
      this.parmValue.max_price = msg.online;
      await this.goodsSearch();
    },
    //变动查询
    async goodsSearch() {
      if (
        (this.parmValue.min_price !== "" && this.parmValue.max_price === "") ||
        (this.parmValue.min_price === "" && this.parmValue.max_price !== "")
      ) {
        this.$message.warning("价格区间不完整！");
        return;
      }
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
      // const res = await asyncRequest.list(model);

      // if (res && res.code === 0) {
      //   this.loading = false;
      //   await this.searchList();
      // } else if (res && res.code >= 100 && res.code <= 104) {
      //   await this.logout();
      // } else {
      //   this.loading = false;
      //   this.$message.warning(res.message);
      // }
      // console.log(res);
    },
  },
};
</script>

<style lang="scss" scoped>
/deep/ .el-dialog {
  width: 1024px;
}
/deep/ .el-input__inner {
  height: 30px;
  line-height: 30px;
}
</style>
